//
//  BiorhythmViewController.m
//  Biorhythm
//
//  Created by 유동근 on 09. 05. 11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "BiorhythmViewController.h"
#import "GraphView.h"

@implementation BiorhythmViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	[self changeDate:birthDay];

	[birthDay addTarget:self action:@selector(changeDate:) 
	   forControlEvents:UIControlEventValueChanged];
	
	NSDate *now = [NSDate date]; 
	birthDay.maximumDate = now;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

-(IBAction)changeDate:(id)sender
{
	unsigned unitFlags = NSYearCalendarUnit | NSMonthCalendarUnit |  
						 NSDayCalendarUnit; 
	NSCalendar *calendar = [NSCalendar currentCalendar];
	NSDate *now = [NSDate date]; 
    NSDateComponents *birthDate = [calendar components:unitFlags 
											  fromDate:[birthDay date]];
    NSDateComponents *currentDate = [calendar components:unitFlags
												fromDate:now];
	
	currDay = [currentDate day];
	
	[self reCalcBiorhythmData:birthDate andCurrentDate:currentDate];
	[graphView setNeedsDisplay];
}

- (void)reCalcBiorhythmData:(NSDateComponents*)birthDate 
			 andCurrentDate:(NSDateComponents*)currentDate
{
    /* 현재 설정된 날짜의 1일 부터 생일 사이의 날수를 구한다. */ 
    NSDateComponents *firstDate = [[NSDateComponents alloc] init];
    [firstDate setYear:[currentDate year]];
    [firstDate setMonth:[currentDate month]];
    [firstDate setDay:1];
    
    NSDate *tempDay = [[NSCalendar currentCalendar] dateFromComponents:firstDate];
    NSDate *birthDay = [[NSCalendar currentCalendar] dateFromComponents:birthDate];
    
    NSTimeInterval ti = [tempDay timeIntervalSinceDate:birthDay];
    [firstDate release];
	
    /* 현재 설정된 날짜의 1일까지 총 일수를 구한다 */
    double days = ceil(fabs(ti) / ONEDAY_SECOND);
    
    /* 한 달치의 바이오리듬 데이터를 구한다 */
    static const double bioPeriod[MAX_BIORHYTHMDATATYPE] = {
        23.0, 28.0, 33.0	// 신체, 감성, 지성
    }; 
    
    for (int i = 0; i < 31; i++) {
        for(int j = 0; j < MAX_BIORHYTHMDATATYPE; j++) {
            _biorhythmData[i][j] = sin((days/bioPeriod[j]) * 2 * PI) * 100;
        }
        days += 1.0;
    }
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField { 
	[theTextField resignFirstResponder]; 
	
	return YES; 	
} 

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [super dealloc];
}

@end
