//
//  BiorhythmViewController.m
//  Biorhythm
//
//  Created by 유동근 on 09. 05. 11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "BiorhythmViewController.h"
#import "GraphView.h"
#import "TableViewController.h"
#import "EditPersonViewContoller.h"

@implementation BiorhythmViewController

@synthesize arrayPerson;
/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
//	[self changeDate:birthDay];

	[birthDay addTarget:self action:@selector(changeDate:) 
	   forControlEvents:UIControlEventValueChanged];
	
	NSDate *now = [NSDate date]; 
	birthDay.maximumDate = now;
	
//	NSString *path = [[[NSBundle mainBundle] resourcePath] stringByAppendingString:@"/people.txt"];
	NSString *path = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, 
														   NSUserDomainMask, YES) 
					   objectAtIndex:0] stringByAppendingString:@"/people.txt"]; 
	NSString *contents = [NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:nil];
	if (contents == nil)
		contents = @"홍길동\t1990-10-01";
	NSMutableArray* array = [[NSMutableArray alloc] init];
	[array addObjectsFromArray:[contents componentsSeparatedByString:@"\n"]];
	self.arrayPerson = array;
	[array release];
	
	NSString* date = [[[self.arrayPerson objectAtIndex:0]
					   componentsSeparatedByString:@"\t"]
					  objectAtIndex:1];
	[self newBirthDay:date];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interself.aceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/
-(IBAction)clickInfo:(id)sender
{
	TableViewController* viewController = [[TableViewController alloc] init];
	UITableView* view = (UITableView*) viewController.view;
	view.dataSource = self;
	view.delegate = viewController;
	UINavigationController* navigationController = nil;
	navigationController = [[UINavigationController alloc] 
							initWithRootViewController:viewController];
	[viewController release];
		
	[self presentModalViewController:navigationController animated:YES];
	[navigationController release];
}
-(NSInteger)numberOfSectionsInTableView:(UITableView*)tableView {
	return 1;
}
-(NSInteger)tableView:(UITableView*)tableView
			numberOfRowsInSection:(NSInteger)section {
	return [arrayPerson count];
}
-(UITableViewCell*)tableView:(UITableView*)tableView cellForRowAtIndexPath:(NSIndexPath*) indexPath {
	NSString* person = [arrayPerson objectAtIndex:[indexPath row]];
	UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:person];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero
									   reuseIdentifier:person] autorelease];
	}
	cell.text = person;
//	cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	cell.accessoryType = UITableViewCellAccessoryDetailDisclosureButton;
	cell.showsReorderControl = YES;
	cell.target = self;
	cell.accessoryAction = @selector(goEdit:);
	return cell;
}
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
	return YES;
}
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle 
											forRowAtIndexPath:(NSIndexPath *)indexPath {
	[tableView beginUpdates];
	[tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] 
					 withRowAnimation:UITableViewRowAnimationRight];
	[self.arrayPerson removeObjectAtIndex:indexPath.row];
	[tableView endUpdates];	// setEditing:NO 전에 호출해야 한다.
	
//	[tableView reloadData];
}

- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
	return YES;
}
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath 
	  toIndexPath:(NSIndexPath *)toIndexPath {
	NSString* person = [self.arrayPerson objectAtIndex:[fromIndexPath row]];
	[self.arrayPerson removeObjectAtIndex:[fromIndexPath row]];
	[self.arrayPerson insertObject:person atIndex:[toIndexPath row]];
}

-(void)goEdit:(id)sender {
	UITableViewCell* cell = (UITableViewCell*) [sender superview];
	UIViewController* viewController = [[EditPersonViewContoller alloc] initWithNibName:@"EditPersonView" 
																				andCell:cell];
	UINavigationController* navigationController = 
				(UINavigationController*) self.modalViewController;
	[navigationController pushViewController:viewController animated:YES];
	[viewController release];
}
//-(NSArray*)sectionIndexTitlesForTableView:(UITableView*)tableView {
//	NSMutableArray* temp = [[[NSMutableArray alloc] init] autorelease];
//	[temp addObject:@"1"];
//	[temp addObject:@"2"];
//	[temp addObject:@"3"];
//	[temp addObject:@"4"];
//	return temp;
//}

- (NSInteger)tableView:(UITableView *)tableView sectionForSectionIndexTitle:(NSString *)title atIndex:(NSInteger)index { 
	
	return index % 2; 
} 

-(void)appendPerson:(NSString*)person {
	[self.arrayPerson addObject:person];
}
-(void)updatePerson:(NSString*)person atIndex:(NSInteger)row {
	[self.arrayPerson replaceObjectAtIndex:row withObject:
	 person];
}
-(void)newBirthDay:(NSString*)date {
	NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init]
									  autorelease];
	[dateFormatter setDateFormat:@"yyyy-MM-dd"];
	[birthDay setDate:[dateFormatter dateFromString:date]];
	[self performSelector:@selector(changeDate:) withObject:birthDay
			   afterDelay:0.5f];
}
-(IBAction)changeDate:(id)sender
{
	unsigned unitFlags = NSYearCalendarUnit | NSMonthCalendarUnit |  
						 NSDayCalendarUnit; 
	NSCalendar *calendar = [NSCalendar currentCalendar];
	NSDate *now = [NSDate date]; 
    NSDateComponents *birthDate = [calendar components:unitFlags 
											  fromDate:[birthDay date]];
    NSDateComponents *currentDate = [calendar components:unitFlags
												fromDate:now];
	
	currDay = [currentDate day];
	
	[self reCalcBiorhythmData:birthDate andCurrentDate:currentDate];
	[graphView setNeedsDisplay];
}

- (void)reCalcBiorhythmData:(NSDateComponents*)birthDate 
			 andCurrentDate:(NSDateComponents*)currentDate
{
    /* 현재 설정된 날짜의 1일 부터 생일 사이의 날수를 구한다. */ 
    NSDateComponents *firstDate = [[NSDateComponents alloc] init];
    [firstDate setYear:[currentDate year]];
    [firstDate setMonth:[currentDate month]];
    [firstDate setDay:1];
    
    NSDate *tempDay = [[NSCalendar currentCalendar] dateFromComponents:firstDate];
    NSDate *birthDay = [[NSCalendar currentCalendar] dateFromComponents:birthDate];
    
    NSTimeInterval ti = [tempDay timeIntervalSinceDate:birthDay];
    [firstDate release];
	
    /* 현재 설정된 날짜의 1일까지 총 일수를 구한다 */
    double days = ceil(fabs(ti) / ONEDAY_SECOND);
    
    /* 한 달치의 바이오리듬 데이터를 구한다 */
    static const double bioPeriod[MAX_BIORHYTHMDATATYPE] = {
        23.0, 28.0, 33.0	// 신체, 감성, 지성
    }; 
    
    for (int i = 0; i < 31; i++) {
        for(int j = 0; j < MAX_BIORHYTHMDATATYPE; j++) {
            _biorhythmData[i][j] = sin((days/bioPeriod[j]) * 2 * PI) * 100;
        }
        days += 1.0;
    }
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField { 
	[theTextField resignFirstResponder]; 
	
	return YES; 	
} 

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[arrayPerson release];
    [super dealloc];
}

@end
