#import "TableViewController.h"
#import "BiorhythmViewController.h"

@implementation TableViewController
-(void)loadView {
	[super loadView];
	[self setTitle:@"사용자 목록"]; 
	UIBarButtonItem* buttonItem = [[[UIBarButtonItem alloc] 
									initWithTitle:@"삭제/이동"
									style:UIBarButtonItemStylePlain 
									target:self 
									action:@selector(goDelete)] 
								   autorelease]; 
//	[[self navigationItem] setLeftBarButtonItem:[self editButtonItem] animated:YES]; 
	[[self navigationItem] setLeftBarButtonItem:buttonItem animated:YES]; 
	
	buttonItem = [[[UIBarButtonItem alloc] 
				   initWithBarButtonSystemItem:UIBarButtonSystemItemAdd
										target:self 
										action:@selector(goAppend)] 
												autorelease]; 
	[[self navigationItem] setRightBarButtonItem:buttonItem animated:YES]; 
}
-(void)goDelete {
	NSString* title = nil;
	if ([self.tableView isEditing]) {
		[self.tableView setEditing:NO animated:YES];
		title = @"삭제/이동";
		[[self.navigationItem rightBarButtonItem] setEnabled:YES];
	}
	else {
		[self.tableView setEditing:YES animated:YES];
		title = @"완료";
		[[self.navigationItem rightBarButtonItem] setEnabled:NO];
	}
	[self.navigationItem.leftBarButtonItem setTitle:title];
}
-(void)goAppend {
	BiorhythmViewController* viewController = (BiorhythmViewController*)
				[self.navigationController parentViewController];
	[viewController appendPerson:@"홍길동\t1990-10-01"];
	[self.tableView reloadData];
}
//-(UITableViewCellEditingStyle)tableView:(UITableView *)tableView 
//		editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath {
//		return UITableViewCellEditingStyleInsert;
//}
	
-(void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath*)indexPath {
	UITableViewCell* cell = [self.tableView cellForRowAtIndexPath:indexPath];
	NSString* date = [[cell.text componentsSeparatedByString:@"\t"] 
						objectAtIndex:1];
	BiorhythmViewController* viewController = (BiorhythmViewController*)
				[self.navigationController parentViewController];
	[viewController newBirthDay:date];
	[self.navigationController dismissModalViewControllerAnimated:YES];
	
	NSMutableArray* arrayPerson = viewController.arrayPerson;
	[arrayPerson removeAllObjects];

	NSString *contents = nil;
	NSInteger rows = [self.tableView numberOfRowsInSection:0];
	for (int i = 0; i < rows ;i++) {
		UITableViewCell* cell = [self.tableView cellForRowAtIndexPath:
								 [NSIndexPath indexPathForRow:i 
													inSection:0]];
		[arrayPerson addObject:cell.text];
		if (contents == nil)
			contents = cell.text;
		else
			contents = [contents stringByAppendingString:cell.text];
		if (i+1 < rows)
			contents = [contents stringByAppendingString:@"\n"];
	}
		
	NSString *path = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, 
														   NSUserDomainMask, YES) 
					   objectAtIndex:0] stringByAppendingString:@"/people.txt"]; 
	[contents writeToFile:path atomically:NO 
				 encoding:NSUTF8StringEncoding error:nil];
}
-(void)tableView:(UITableView*)tableView didEndEditingRowAtIndexPath:(NSIndexPath*)indexPath {
}
-(NSIndexPath*)tableView:(UITableView*)tableView willSelectRowAtIndexPath:(NSIndexPath*)indexPath {
	return indexPath;
}
-(void)dealloc
{
	[super dealloc];
}
@end
