#import "ColorViewController.h"
#import "FingerDrawForImageAppDelegate.h"
#import "FingerDrawForImageViewController.h"
#import "MyUIView.h"

UIImage* CreateImage(float widthPen, CGColorRef color);

@implementation ColorViewController
-(void)viewDidLoad {
	slider.minimumValue = 0;
	slider.maximumValue = 100;
	slider.value = 	[[self myUIView] _widthPen];
	
	[slider addTarget:self action:@selector(changleValue:) 
	 forControlEvents:UIControlEventValueChanged];
}
-(MyUIView*)myUIView {
	FingerDrawForImageAppDelegate* appDelegate = 
			(FingerDrawForImageAppDelegate*)
				[[UIApplication sharedApplication] delegate];
	FingerDrawForImageViewController* viewController = [appDelegate viewController];
	UIView* imageView = [viewController 
						 viewForZoomingInScrollView:(UIScrollView*) viewController.view];
	MyUIView* view = (MyUIView*) [[imageView subviews] objectAtIndex:0];
	return view;
}
-(IBAction)changleValue:(id)sender
{
	MyUIView* view = [self myUIView];
	CGColorRef color = view._colorPen;
	
	CGImageRef oldimage = [currImage CGImage];
	currImage = CreateImage([slider value], color);
	[slider setThumbImage:currImage forState:UIControlStateNormal];
	[slider setThumbImage:currImage forState:UIControlStateHighlighted];
	if (oldimage)
		CFRelease(oldimage);
	
	NSLog(@"%f\n", slider.value);
	[[self myUIView] setWidthPen:slider.value];
}
-(void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
	UITouch*	touch = [touches anyObject];
	UIView*		view = [touch view];
	if (view != self.view)
	{
		CGColorRef color = [[view backgroundColor] CGColor];
		MyUIView* view = [self myUIView];
		[view setColorPen:color];
		[self changleValue:slider];
	}
}
@end


CGContextRef CreateBitmapContext (int pixelsWide,
								  int pixelsHigh)
{
    CGContextRef    context = NULL;
    CGColorSpaceRef colorSpace;
	
    colorSpace = CGColorSpaceCreateDeviceRGB();
    context = CGBitmapContextCreate (NULL,
									 pixelsWide,
									 pixelsHigh,
									 8,
									 pixelsWide*4,
									 colorSpace,
									 kCGImageAlphaPremultipliedLast);
    if (context== NULL)
        return NULL;
    CGColorSpaceRelease( colorSpace );
	
    return context;
}

UIImage* CreateImage(float widthPen, CGColorRef color)
{
	CGContextRef context  = CreateBitmapContext(widthPen, widthPen);
	if (context == nil)
		return nil;
	
	CGContextAddEllipseInRect(context, CGRectMake(0.0f, 0.0f, widthPen, widthPen));

	CGContextSetFillColorWithColor(context, color);
	CGContextFillPath(context);
	
	CGImageRef imageRef = CGBitmapContextCreateImage (context);
	CGContextRelease(context);
	return [UIImage imageWithCGImage:imageRef];
}

