//
//  main.m
//  Inherit
//
//  Created by ??? on 09. 04. 15.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Cocoa/runtime.h>

//------------------------------------------------------------------------------
void dynamicMethod(id self, SEL _cmd)
{
	printf("dynamicMethod called\n");
}
//------------------------------------------------------------------------------
@interface Base : NSObject
-(void) display;
+(void) baseFunction;
@end

@implementation Base
-(void) display
{
	printf ("Base display\n");
}
+(void) baseFunction
{
	printf ("Base baseFunction\n");
}
+ (BOOL)resolveInstanceMethod:(SEL)aSEL
{
    if (aSEL == @selector(resolveThisMethodDynamically)) {
		class_addMethod([self class], aSEL, (IMP) dynamicMethodIMP, "v@:");
		return YES;
    }
    return [super resolveInstanceMethod:aSEL];
}
@end

//------------------------------------------------------------------------------
@interface Derived : Base
-(void) display;
@end

@implementation Derived
-(void) display
{
	printf ("Derived display\n");
}
@end
//------------------------------------------------------------------------------

int main ()
{
	NSObject* p = [[NSObject alloc] init];
	[p release];
	
	Base* pbase = [Base alloc];
	IMP display = [[Base class] instanceMethodForSelector:@selector(display)];
	IMP display2 = [[Base class] instanceMethodForSelector:sel_getUid("display")];
	if (display == display2)
		printf("@select equal sel_getUid\n");
	
	[pbase performSelector:sel_getUid("display")];
	display(pbase,@selector(aaaa));
	[pbase display];
	[pbase release];
	pbase = [Derived alloc];
	if ([pbase isKindOfClass:[Derived class]])
		printf("Derived class\n");
	else
		printf("Not Derived class\n");
	[pbase display];
	
	
	if ([pbase isKindOfClass:[Base class]])
		printf ("pbase is the Derived\n");
	
	[pbase release];

	pbase = [Base alloc];
	IMP imp = [pbase methodForSelector:@selector(display)];
	for (int i = 0; i < 10 ;i++)
		imp (pbase, @selector(display));

	[pbase resolveInstanceMethod:@selector(dynamicMethod)];
	
	[pbase dynamicMethod];
	
	[pbase release];
//	id obj = [Derived alloc];
//	[obj display];
//	[obj release];
	
	return 0;
}
