//
//  WhereAmIViewController.m
//  WhereAmI
//
//  Created by 유동근 on 09. 06. 14.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "WhereAmIViewController.h"
#import <AudioToolbox/AudioToolbox.h>

@implementation WhereAmIViewController

@synthesize locationManager;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
	[super loadView];
	
	locationManager = [[CLLocationManager alloc] init];
	locationManager.delegate = self;
	locationManager.desiredAccuracy = kCLLocationAccuracyBest;
	if (![locationManager locationServicesEnabled])
	{
		NSLog(@"Check [설정 > 일반 > 위치 서비스]");
		return;
	}
}

-(IBAction)doSearch
{
	[locationManager startUpdatingLocation];
}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation
{
	CLLocationCoordinate2D loc2D = [newLocation coordinate];
//	location.text = [NSString stringWithFormat:@"위치(%f %f) 반경 %f m에 위치, 이동 속도 %f", 
//					 loc2D.latitude, loc2D.longitude, [newLocation horizontalAccuracy],
//					 [newLocation speed]];
	
	NSString *mapString = [NSString stringWithFormat: @"http://maps.google.com/maps?q=%f,%f", 
						   loc2D.latitude, loc2D.longitude];
	NSURL *url = [NSURL URLWithString:mapString];
	
	[[UIApplication sharedApplication] openURL:url];
}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error
{
}


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[locationManager release];
    [super dealloc];
}

@end
