//
//  WordBookViewController.m
//  WordBook
//
//  Created by 유동근 on 09. 05. 26.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "WordBookViewController.h"
#import "WordViewController.h"
#import "FMDatabase.h"

@implementation WordBookViewController

//@synthesize words;
@synthesize searchResult;
@synthesize path;
@synthesize key;
/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
	[super loadView];
	
	[self setTitle:@"단어집"]; 
	UIBarButtonItem* buttonItem = [[[UIBarButtonItem alloc] 
									initWithTitle:@"삭제"
									style:UIBarButtonItemStylePlain 
									target:self 
									action:@selector(goDelete)] 
								   autorelease]; 
	[[self navigationItem] setLeftBarButtonItem:buttonItem animated:YES]; 
	
	buttonItem = [[[UIBarButtonItem alloc] 
				   initWithBarButtonSystemItem:UIBarButtonSystemItemAdd
				   target:self 
				   action:@selector(goAppend)] 
				  autorelease]; 
	[[self navigationItem] setRightBarButtonItem:buttonItem animated:YES]; 
	
	UISearchBar* searchBar = [[UISearchBar alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 44.0)];
	[[self navigationItem] setTitleView:searchBar];
	searchBar.delegate = self;
	[searchBar release];
	
	self.path = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0] 
					  stringByAppendingString:@"/dictionary.db3"];
	NSFileManager *fileManager = [NSFileManager defaultManager]; 
	if ([fileManager fileExistsAtPath:path] == NO) {
		char *sql = "CREATE TABLE wordBookTable (word CHAR PRIMARY KEY NOT NULL, sense CHAR)"; 
		sqlite3 *database; 
		if (sqlite3_open([path UTF8String], &database) != SQLITE_OK ||
			sqlite3_exec(database, sql, nil,nil,nil) != SQLITE_OK) { 
			sqlite3_close(database); 
			return; 
		} 
		sqlite3_close(database);
	}
	db = [[FMDatabase databaseWithPath:self.path] retain];
	[db setLogsErrors:TRUE];
	[db setTraceExecution:TRUE];
	if (![db open])
		NSLog(@"Not open.");
	else
		NSLog(@"DB Open...");
	
}
-(void)goDelete {
	NSString* title = nil;
	if ([self.tableView isEditing]) {
		[self.tableView setEditing:NO animated:YES];
		title = @"삭제";
		[[self.navigationItem rightBarButtonItem] setEnabled:YES];
	}
	else {
		[self.tableView setEditing:YES animated:YES];
		title = @"완료";
		[[self.navigationItem rightBarButtonItem] setEnabled:NO];
	}
	[self.navigationItem.leftBarButtonItem setTitle:title];
}
-(void)goAppend {
	UIViewController* viewController = [[WordViewController alloc] initWithNibName:@"WordView" bundle:nil];
	[self.navigationController pushViewController:viewController animated:YES];
	[viewController release];
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle 
					forRowAtIndexPath:(NSIndexPath *)indexPath {
	if (editingStyle == UITableViewCellEditingStyleDelete) {
		[tableView beginUpdates];
		[tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] 
						 withRowAnimation:UITableViewRowAnimationRight];
		[self.searchResult removeObjectAtIndex:indexPath.row];
		[tableView endUpdates];	// setEditing:NO 전에 호출해야 한다.
		
		sqlite3 *database; 
		if (sqlite3_open([self.path UTF8String], &database) != SQLITE_OK) { 
			sqlite3_close(database); 
			return; 
		} 
		NSString* sqlQuery = [NSString stringWithFormat:@"DELETE FROM wordBookTable where word like '%@%%'", self.key];
		const char* sql = [sqlQuery UTF8String]; 
		if (sqlite3_exec(database, sql, nil, nil, nil) != SQLITE_OK) { 
			NSLog(@"Delete error\n");
		}
		sqlite3_close(database);
	}
}
-(void)saveDictionary:(NSString*)word andSense:(NSString*)sense {
	[db executeUpdate:@"INSERT INTO wordBookTable (word,sense) VALUES(?,?)", word, sense];
//	sqlite3 *database; 
//	if (sqlite3_open([self.path UTF8String], &database) != SQLITE_OK) { 
//		sqlite3_close(database); 
//		return; 
//		
//	} 
//	sqlite3_stmt *statement; 
//	char *sql = "INSERT INTO wordBookTable (word,sense) VALUES(?,?)"; 
//	if (sqlite3_prepare_v2(database, sql, -1, &statement, NULL) == SQLITE_OK) { 
//		sqlite3_bind_text(statement, 1, [word UTF8String], -1, SQLITE_TRANSIENT); 
//		sqlite3_bind_text(statement, 2, [sense UTF8String], -1, SQLITE_TRANSIENT); 
//		sqlite3_step(statement);
//	}	
//	sqlite3_finalize(statement);
//	sqlite3_close(database);
}
//- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText {
//	[self searchBarSearchButtonClicked:searchBar];
//}
-(void)searchBarSearchButtonClicked:(UISearchBar *)searchBar {
	if (self.searchResult == nil)
		self.searchResult = [[NSMutableArray new] autorelease];
	[self.searchResult removeAllObjects];
	
	NSString* sqlQuery = [NSString stringWithFormat:@"SELECT sense FROM wordBookTable where word like '%@%%'", searchBar.text];
	FMResultSet* rs = [db executeQuery:sqlQuery];
	while ([rs next]) {
		[self.searchResult addObject:[rs stringForColumn:@"sense"]];
	}
//	sqlite3 *database; 
//	if (sqlite3_open([self.path UTF8String], &database) != SQLITE_OK) { 
//		sqlite3_close(database); 
//		return; 
//		
//	} 
//	NSString* sqlQuery = [NSString stringWithFormat:@"SELECT sense FROM wordBookTable where word like '%@%%'", searchBar.text];
//	sqlite3_stmt *statement; 
//	const char* sql = [sqlQuery UTF8String]; 
//	if (sqlite3_prepare_v2(database, sql, -1, &statement, NULL) == SQLITE_OK) { 
//		if (self.searchResult == nil)
//			self.searchResult = [[NSMutableArray new] autorelease];
//		[self.searchResult removeAllObjects];
//		while (sqlite3_step(statement)==SQLITE_ROW) { 
//			[self.searchResult addObject:
//			 [NSString stringWithUTF8String:(char*)sqlite3_column_text(statement, 0)]];
//		}
//	}
//	sqlite3_finalize(statement);
//	sqlite3_close(database);
	
	[(UITableView*)self.view reloadData];
	[searchBar resignFirstResponder]; 
	
	self.key = searchBar.text;
}

-(NSInteger)numberOfSectionsInTableView:(UITableView*)tableView {
	return 1;
}
-(NSInteger)tableView:(UITableView*)tableView
						numberOfRowsInSection:(NSInteger)section {
	return [self.searchResult count];
}
-(UITableViewCell*)tableView:(UITableView*)tableView cellForRowAtIndexPath:(NSIndexPath*) indexPath {
	NSString* sense = [self.searchResult objectAtIndex:[indexPath row]];
	UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:sense];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero
									   reuseIdentifier:sense] autorelease];
	}
	cell.text = sense;
	return cell;
}
/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[searchResult release];
//	[words release];
	[path release];
	[key release];
	[db release];
    [super dealloc];
}

@end
