//
//  WordBookViewController.m
//  WordBook
//
//  Created by 유동근 on 09. 05. 26.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "WordBookViewController.h"
#import "WordViewController.h"

@implementation WordBookViewController

@synthesize words;
@synthesize searchResult;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
	[super loadView];
	
	[self setTitle:@"단어집"]; 
	UIBarButtonItem* buttonItem = [[[UIBarButtonItem alloc] 
									initWithTitle:@"삭제"
									style:UIBarButtonItemStylePlain 
									target:self 
									action:@selector(goDelete)] 
								   autorelease]; 
	[[self navigationItem] setLeftBarButtonItem:buttonItem animated:YES]; 
	
	buttonItem = [[[UIBarButtonItem alloc] 
				   initWithBarButtonSystemItem:UIBarButtonSystemItemAdd
				   target:self 
				   action:@selector(goAppend)] 
				  autorelease]; 
	[[self navigationItem] setRightBarButtonItem:buttonItem animated:YES]; 
	
	UISearchBar* searchBar = [[UISearchBar alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 44.0)];
	[[self navigationItem] setTitleView:searchBar];
	searchBar.delegate = self;
	[searchBar release];
	
	NSString* path = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0] 
					  stringByAppendingString:@"/dictionary.plist"];
	NSData* xmlData = [NSData dataWithContentsOfFile:path];
	NSString *error; 
	NSPropertyListFormat format;
	self.words = [NSPropertyListSerialization propertyListFromData:xmlData 
												  mutabilityOption:NSPropertyListMutableContainersAndLeaves 
															format:&format 
												  errorDescription:&error];
	
	if (self.words == nil)
		self.words = [NSMutableDictionary new];
}
-(void)goDelete {
}
-(void)goAppend {
	UIViewController* viewController = [[WordViewController alloc] initWithNibName:@"WordView" bundle:nil];
	[self.navigationController pushViewController:viewController animated:YES];
	[viewController release];
}
-(void)saveDictionary:(NSString*)word andSense:(NSString*)sense {
	[words setObject:sense forKey:word];
	NSString* path = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0] 
					  stringByAppendingString:@"/dictionary.plist"];
	[words writeToFile:path atomically:NO]; 
//	NSString *error; 
//	NSData *xmlData = [NSPropertyListSerialization dataFromPropertyList:words format:NSPropertyListXMLFormat_v1_0 errorDescription:&error]; 
//	if(xmlData) 
//		[xmlData writeToFile:path atomically:YES]; 
//	else 
//	{ 
//		NSLog(error); 
//		[error release]; 
//	}
}
-(void)searchBarSearchButtonClicked:(UISearchBar *)searchBar {
	self.searchResult = [self.words objectsForKeys:[NSArray arrayWithObject:searchBar.text]
									notFoundMarker:@"not found"];
	[(UITableView*)self.view reloadData];
	[searchBar resignFirstResponder]; 
}

-(NSInteger)numberOfSectionsInTableView:(UITableView*)tableView {
	return 1;
}
-(NSInteger)tableView:(UITableView*)tableView
						numberOfRowsInSection:(NSInteger)section {
	return [self.searchResult count];
}
-(UITableViewCell*)tableView:(UITableView*)tableView cellForRowAtIndexPath:(NSIndexPath*) indexPath {
	NSString* sense = [self.searchResult objectAtIndex:[indexPath row]];
	UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:sense];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero
									   reuseIdentifier:sense] autorelease];
	}
	cell.text = sense;
	return cell;
}
/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[searchResult release];
	[words release];
    [super dealloc];
}

@end
